/*
 * generated by Xtext 2.9.0
 */
package org.xtext.example.mydsl.validation

import java.util.HashSet
import java.util.List
import org.eclipse.emf.ecore.EStructuralFeature
import org.eclipse.xtext.validation.Check
import org.xtext.example.mydsl.dslA.ServiceMethod
import org.xtext.example.mydsl.dslB.Client
import org.xtext.example.mydsl.dslB.Host
import org.xtext.example.mydsl.dslB.DslBPackage

/**
 * This class contains custom validation rules. 
 *
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#validation
 */
class DslBValidator extends AbstractDslBValidator {
	
	@Check
	def checkDuplicateServiceMethodDeclaration(Client client) {
		checkDuplicateServiceMethodDeclaration(client.serviceMethods, DslBPackage::eINSTANCE.client_ServiceMethods)
	}
	
	@Check
	def checkDuplicateServiceMethodDeclaration(Host host) {
		checkDuplicateServiceMethodDeclaration(host.serviceMethods, DslBPackage::eINSTANCE.host_ServiceMethods)
		 	
	}
	
	def checkDuplicateServiceMethodDeclaration(List<ServiceMethod> serviceMethods, EStructuralFeature feature) {
		val serviceMethodSet = new HashSet(serviceMethods)
		if (serviceMethodSet.size != serviceMethods.size) {
			error("Duplicate service method declaration", feature)
			return 
		}
	}
}
