/*
 * generated by Xtext 2.9.0
 */
package org.xtext.example.mydsl.serializer;

import com.google.inject.Inject;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.acceptor.SequenceFeeder;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import org.eclipse.xtext.serializer.sequencer.ITransientValueService.ValueTransient;
import org.xtext.example.mydsl.dslA.DslAPackage;
import org.xtext.example.mydsl.dslA.Import;
import org.xtext.example.mydsl.dslA.Model;
import org.xtext.example.mydsl.dslA.PackageDeclaration;
import org.xtext.example.mydsl.dslA.Service;
import org.xtext.example.mydsl.dslA.ServiceMethod;
import org.xtext.example.mydsl.services.DslAGrammarAccess;

@SuppressWarnings("all")
public class DslASemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private DslAGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == DslAPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case DslAPackage.IMPORT:
				sequence_Import(context, (Import) semanticObject); 
				return; 
			case DslAPackage.MODEL:
				sequence_Model(context, (Model) semanticObject); 
				return; 
			case DslAPackage.PACKAGE_DECLARATION:
				sequence_PackageDeclaration(context, (PackageDeclaration) semanticObject); 
				return; 
			case DslAPackage.SERVICE:
				sequence_Service(context, (Service) semanticObject); 
				return; 
			case DslAPackage.SERVICE_METHOD:
				sequence_ServiceMethod(context, (ServiceMethod) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * Contexts:
	 *     Import returns Import
	 *     Parts returns Import
	 *
	 * Constraint:
	 *     importedNamespace=QualifiedNameWithWildcard
	 */
	protected void sequence_Import(ISerializationContext context, Import semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, DslAPackage.Literals.IMPORT__IMPORTED_NAMESPACE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, DslAPackage.Literals.IMPORT__IMPORTED_NAMESPACE));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getImportAccess().getImportedNamespaceQualifiedNameWithWildcardParserRuleCall_1_0(), semanticObject.getImportedNamespace());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Model returns Model
	 *
	 * Constraint:
	 *     elements+=PackageDeclaration+
	 */
	protected void sequence_Model(ISerializationContext context, Model semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     PackageDeclaration returns PackageDeclaration
	 *
	 * Constraint:
	 *     (name=QualifiedName elements+=Parts*)
	 */
	protected void sequence_PackageDeclaration(ISerializationContext context, PackageDeclaration semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     ServiceMethod returns ServiceMethod
	 *
	 * Constraint:
	 *     (name=ID methodType=ServiceMethodType)
	 */
	protected void sequence_ServiceMethod(ISerializationContext context, ServiceMethod semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, DslAPackage.Literals.SERVICE_METHOD__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, DslAPackage.Literals.SERVICE_METHOD__NAME));
			if (transientValues.isValueTransient(semanticObject, DslAPackage.Literals.SERVICE_METHOD__METHOD_TYPE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, DslAPackage.Literals.SERVICE_METHOD__METHOD_TYPE));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getServiceMethodAccess().getNameIDTerminalRuleCall_0_0(), semanticObject.getName());
		feeder.accept(grammarAccess.getServiceMethodAccess().getMethodTypeServiceMethodTypeParserRuleCall_2_0(), semanticObject.getMethodType());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Parts returns Service
	 *     Service returns Service
	 *
	 * Constraint:
	 *     (name=ID services+=ServiceMethod*)
	 */
	protected void sequence_Service(ISerializationContext context, Service semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
}
