/*
 * generated by Xtext 2.9.0
 */
package org.xtext.example.mydsl.serializer;

import com.google.inject.Inject;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.acceptor.SequenceFeeder;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import org.eclipse.xtext.serializer.sequencer.ITransientValueService.ValueTransient;
import org.xtext.example.mydsl.dslB.Client;
import org.xtext.example.mydsl.dslB.DslBPackage;
import org.xtext.example.mydsl.dslB.Host;
import org.xtext.example.mydsl.dslB.Import;
import org.xtext.example.mydsl.dslB.Model;
import org.xtext.example.mydsl.dslB.PkgDeclaration;
import org.xtext.example.mydsl.services.DslBGrammarAccess;

@SuppressWarnings("all")
public class DslBSemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private DslBGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == DslBPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case DslBPackage.CLIENT:
				sequence_Client(context, (Client) semanticObject); 
				return; 
			case DslBPackage.HOST:
				sequence_Host(context, (Host) semanticObject); 
				return; 
			case DslBPackage.IMPORT:
				sequence_Import(context, (Import) semanticObject); 
				return; 
			case DslBPackage.MODEL:
				sequence_Model(context, (Model) semanticObject); 
				return; 
			case DslBPackage.PKG_DECLARATION:
				sequence_PkgDeclaration(context, (PkgDeclaration) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * Contexts:
	 *     Parts returns Client
	 *     Client returns Client
	 *
	 * Constraint:
	 *     (service=[Service|ID] serviceMethods+=[ServiceMethod|ID]+)
	 */
	protected void sequence_Client(ISerializationContext context, Client semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Parts returns Host
	 *     Host returns Host
	 *
	 * Constraint:
	 *     (service=[Service|ID] serviceMethods+=[ServiceMethod|ID]+)
	 */
	protected void sequence_Host(ISerializationContext context, Host semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Parts returns Import
	 *     Import returns Import
	 *
	 * Constraint:
	 *     importedNamespace=QualifiedNameWithWildcard
	 */
	protected void sequence_Import(ISerializationContext context, Import semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, DslBPackage.Literals.IMPORT__IMPORTED_NAMESPACE) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, DslBPackage.Literals.IMPORT__IMPORTED_NAMESPACE));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getImportAccess().getImportedNamespaceQualifiedNameWithWildcardParserRuleCall_1_0(), semanticObject.getImportedNamespace());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Model returns Model
	 *
	 * Constraint:
	 *     packages+=PkgDeclaration+
	 */
	protected void sequence_Model(ISerializationContext context, Model semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     PkgDeclaration returns PkgDeclaration
	 *
	 * Constraint:
	 *     (name=QualifiedName elements+=Parts*)
	 */
	protected void sequence_PkgDeclaration(ISerializationContext context, PkgDeclaration semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
}
