/*
 * generated by Xtext 2.9.0
 */
package org.xtext.example.mydsl.scoping

import org.eclipse.emf.ecore.EObject
import org.eclipse.emf.ecore.EReference
import org.eclipse.xtext.EcoreUtil2
import org.eclipse.xtext.scoping.Scopes
import org.xtext.example.mydsl.dslA.Service
import org.xtext.example.mydsl.dslA.ServiceMethod
import org.xtext.example.mydsl.dslB.Client
import org.xtext.example.mydsl.dslB.DslBPackage
import org.xtext.example.mydsl.dslB.Host

/**
 * This class contains custom scoping description.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#scoping
 * on how and when to use it.
 */
class DslBScopeProvider extends AbstractDslBScopeProvider {

	override getScope(EObject context, EReference reference) {
		if (context instanceof Client) {
			if (reference == DslBPackage.Literals.CLIENT__SERVICE_METHODS) {
				return createScopeForServiceMethods((context as Client).service)
			}	
		} 
		else if (context instanceof Host) {
			if (reference == DslBPackage.Literals.HOST__SERVICE_METHODS) {
				return createScopeForServiceMethods((context as Host).service)
			}	
		} 
		return super.getScope(context, reference)
	}
	
	def createScopeForServiceMethods(Service service) {
		var candidates = EcoreUtil2.getAllContentsOfType(service, ServiceMethod)
		return Scopes.scopeFor(candidates)
	}
}
