/**
 * generated by Xtext 2.9.0
 */
package org.xtext.example.mydsl.scoping;

import com.google.common.base.Objects;
import java.util.List;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.xtext.EcoreUtil2;
import org.eclipse.xtext.scoping.IScope;
import org.eclipse.xtext.scoping.Scopes;
import org.xtext.example.mydsl.dslA.Service;
import org.xtext.example.mydsl.dslA.ServiceMethod;
import org.xtext.example.mydsl.dslB.Client;
import org.xtext.example.mydsl.dslB.DslBPackage;
import org.xtext.example.mydsl.dslB.Host;
import org.xtext.example.mydsl.scoping.AbstractDslBScopeProvider;

/**
 * This class contains custom scoping description.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#scoping
 * on how and when to use it.
 */
@SuppressWarnings("all")
public class DslBScopeProvider extends AbstractDslBScopeProvider {
  @Override
  public IScope getScope(final EObject context, final EReference reference) {
    if ((context instanceof Client)) {
      boolean _equals = Objects.equal(reference, DslBPackage.Literals.CLIENT__SERVICE_METHODS);
      if (_equals) {
        Service _service = ((Client) context).getService();
        return this.createScopeForServiceMethods(_service);
      }
    } else {
      if ((context instanceof Host)) {
        boolean _equals_1 = Objects.equal(reference, DslBPackage.Literals.HOST__SERVICE_METHODS);
        if (_equals_1) {
          Service _service_1 = ((Host) context).getService();
          return this.createScopeForServiceMethods(_service_1);
        }
      }
    }
    return super.getScope(context, reference);
  }
  
  public IScope createScopeForServiceMethods(final Service service) {
    List<ServiceMethod> candidates = EcoreUtil2.<ServiceMethod>getAllContentsOfType(service, ServiceMethod.class);
    return Scopes.scopeFor(candidates);
  }
}
