/**
 * generated by Xtext 2.9.0
 */
package org.xtext.example.mydsl.validation;

import java.util.HashSet;
import java.util.List;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.xtext.validation.Check;
import org.xtext.example.mydsl.dslA.ServiceMethod;
import org.xtext.example.mydsl.dslB.Client;
import org.xtext.example.mydsl.dslB.DslBPackage;
import org.xtext.example.mydsl.dslB.Host;
import org.xtext.example.mydsl.validation.AbstractDslBValidator;

/**
 * This class contains custom validation rules.
 * 
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#validation
 */
@SuppressWarnings("all")
public class DslBValidator extends AbstractDslBValidator {
  @Check
  public void checkDuplicateServiceMethodDeclaration(final Client client) {
    EList<ServiceMethod> _serviceMethods = client.getServiceMethods();
    EReference _client_ServiceMethods = DslBPackage.eINSTANCE.getClient_ServiceMethods();
    this.checkDuplicateServiceMethodDeclaration(_serviceMethods, _client_ServiceMethods);
  }
  
  @Check
  public void checkDuplicateServiceMethodDeclaration(final Host host) {
    EList<ServiceMethod> _serviceMethods = host.getServiceMethods();
    EReference _host_ServiceMethods = DslBPackage.eINSTANCE.getHost_ServiceMethods();
    this.checkDuplicateServiceMethodDeclaration(_serviceMethods, _host_ServiceMethods);
  }
  
  public void checkDuplicateServiceMethodDeclaration(final List<ServiceMethod> serviceMethods, final EStructuralFeature feature) {
    final HashSet<ServiceMethod> serviceMethodSet = new HashSet<ServiceMethod>(serviceMethods);
    int _size = serviceMethodSet.size();
    int _size_1 = serviceMethods.size();
    boolean _notEquals = (_size != _size_1);
    if (_notEquals) {
      this.error("Duplicate service method declaration", feature);
      return;
    }
  }
}
